// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_peers_by_name.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const listPeersByName = `-- name: ListPeersByName :many

SELECT
    p.id,
    p.name,
    p.manager_address,
    -- coalesce is used to return an empty string if the value is null. the code generate by sqlc is unable to handle null values in this context.
    coalesce( STRING_AGG(pr.role::text, ', '),'')::text AS roles
FROM peers.peers as p
LEFT JOIN peers.peers_roles pr ON p.id = pr.peer_id
WHERE
    p.name IS NOT NULL AND
    p.manager_address IS NOT NULL AND
    lower(p.name) like lower($2::text) AND
    (
             $3::text = ''
        OR
            ($4::text = 'asc' AND p.id > $3::text)
        OR
            ($4::text = 'desc' AND p.id < $3::text)
    )
GROUP BY p.id
ORDER BY
    CASE
        WHEN $4::text = 'asc' THEN p.id END ASC,
    CASE
        WHEN $4::text = 'desc' THEN p.id END DESC
LIMIT $1
`

type ListPeersByNameParams struct {
	Limit             int32
	Name              string
	PaginationStartID string
	OrderDirection    string
}

type ListPeersByNameRow struct {
	ID             string
	Name           pgtype.Text
	ManagerAddress pgtype.Text
	Roles          string
}

// Copyright © VNG Realisatie 2023
// Licensed under the EUPL
func (q *Queries) ListPeersByName(ctx context.Context, arg *ListPeersByNameParams) ([]*ListPeersByNameRow, error) {
	rows, err := q.db.Query(ctx, listPeersByName,
		arg.Limit,
		arg.Name,
		arg.PaginationStartID,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListPeersByNameRow{}
	for rows.Next() {
		var i ListPeersByNameRow
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.ManagerAddress,
			&i.Roles,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
